package com.jz.sms.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.jz.sms.chuanlan.service.ChuanLanSmsService;
import com.jz.sms.dto.*;
import com.jz.sms.repository.SysBatchMapper;
import com.jz.sms.repository.TemplateMapper;
import com.jz.sms.repository.domain.SmsTemplateInfo;
import com.jz.sms.repository.domain.SysBatchInfo;
import com.jz.sms.service.MessageService;
import com.jz.sms.util.id.IdHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class MessageServiceImpl implements MessageService {


    @Autowired
    private SysBatchMapper sysBatchMapper;

    @Autowired
    private TemplateMapper templateMapper;

    @Autowired
    private ChuanLanSmsService chuanLanSmsService;

    /**
     * 短信模板创建
     *
     * @param requestDTO
     * @return
     */
    @Override
    public XfaceDmHubTemplateResponseDTO createTemplate(XfaceDmHubTemplateRequestDTO requestDTO) {

        XfaceDmHubTemplateResponseDTO responseDTO = new XfaceDmHubTemplateResponseDTO();
        try {
//            XfaceClTemplateRequestDTO clTemplateRequestDTO = new XfaceClTemplateRequestDTO();
//            XfaceClTemplateResponseDTO clTemplateResponseDTO = new XfaceClTemplateResponseDTO();
//            logger.info("短信通道请求URL:"+url);
//            logger.info("短信通道返回内容:"+responseStr);
        } catch (Exception exception) {
            // 记录异常日志
            throw exception;
        }
        return responseDTO;

    }

    @Override
    public XfaceDmHubSendResponseDTO send(XfaceDmHubSendRequestDTO requestDTO) {
        try {
            String dmHubBatchId = requestDTO.getBatchId();
            String templateId = requestDTO.getTemplateId();
            String audienceIdType = requestDTO.getAudienceIdType();
            JSONObject data = requestDTO.getData();
            // 获取模板信息
            SmsTemplateInfo templateInfo = templateMapper.selectOne(new SmsTemplateInfo(templateId));
            if (null == templateInfo) {
                return null;
            }

            String content = templateInfo.getContent();
            String smsType = templateInfo.getType();

            // 系统记录批次，不管是单发还是批量发送都当是批量发送处理
            SysBatchInfo info = new SysBatchInfo();
            info.setBatchId(IdHandler.nextId());
            Integer insert = sysBatchMapper.insert(info);

//            chuanLanSmsService.sendByFixed(content);


        } catch (Exception e) {

        }

        return null;
    }

    @Override
    public XfaceDmHubBatchSendResponseDTO batchSend(XfaceDmHubBatchSendRequestDTO requestDTO) {
        return null;
    }
}
